--prohlédněte si skript a nastudujte vložené komentáře
--nakopirujte do pg admin a spusťte
CREATE TABLE student (

    student_uco NUMERIC(10) NOT NULL,

    jmeno VARCHAR(50) NOT NULL,

    prijmeni VARCHAR(50) NOT NULL,

    datum_narozeni DATE,

    pohlavi VARCHAR(1) NOT NULL

);



CREATE TABLE vyuka (

    student_uco NUMERIC(10) NOT NULL,

    predmet_id NUMERIC(10) NOT NULL

);





CREATE TABLE predmet (

    predmet_id NUMERIC(10) NOT NULL,

    ucitel_uco NUMERIC(10),

    nazev_predmetu VARCHAR(50) NOT NULL

);



CREATE TABLE ucitel (

    ucitel_uco NUMERIC (10) NOT NULL,

    jmeno VARCHAR(50) NOT NULL,

    prijmeni VARCHAR(50) NOT NULL

);



ALTER TABLE student ADD 

    CONSTRAINT pk_student

    PRIMARY KEY (student_uco);

 

ALTER TABLE vyuka ADD 

    CONSTRAINT pk_vyuka

    PRIMARY KEY (student_uco, predmet_id);

    

ALTER TABLE predmet ADD 

    CONSTRAINT pk_predmet

    PRIMARY KEY (predmet_id);

    

ALTER TABLE ucitel ADD 

    CONSTRAINT pk_ucitel

    PRIMARY KEY (ucitel_uco);

     

ALTER TABLE predmet ADD 

    CONSTRAINT fk_predmet_ucitel

    FOREIGN KEY (ucitel_uco)

     REFERENCES ucitel (ucitel_uco);

     

ALTER TABLE vyuka ADD 

    CONSTRAINT fk_vyuka_student

    FOREIGN KEY (student_uco)

     REFERENCES student (student_uco);

         

ALTER TABLE vyuka ADD 

    CONSTRAINT fk_vyuka_predmet

    FOREIGN KEY (predmet_id)

    REFERENCES predmet (predmet_id);

   



CREATE TABLE patients (

    patient_id VARCHAR(15) NOT NULL,

    date_of_birth DATE,

    sex VARCHAR(1) 

);



CREATE TABLE patient_study

(

    patient_id VARCHAR(15) NOT NULL,

    study_id NUMERIC (11) NOT NULL,

    study_site NUMERIC(11),

    date_of_enrollment DATE

);



CREATE TABLE studies

(
  study_name       VARCHAR(50)            NOT NULL,
  study_id         NUMERIC(11)            NOT NULL,
  study_title      VARCHAR(255)           NOT NULL,

  description      VARCHAR(500),

  locked           NUMERIC(1)                    DEFAULT 0,

  date_start       DATE,

  is_active        NUMERIC(1)                    DEFAULT 1,

  manager          VARCHAR(30),

  date_terminated  DATE,

  web_url          VARCHAR(255)

);



CREATE TABLE sites

(

    site_id NUMERIC(11) NOT NULL,

    site VARCHAR(255) NOT NULL

 );

 

 CREATE TABLE studies_sites

 (

    study_id NUMERIC(11) NOT NULL,

    site_id NUMERIC(11) NOT NULL

 );

COPY patients FROM 'C:/aa/patients.txt' NULL '' ENCODING 'UTF8';
COPY studies FROM 'C:/aa/studies.txt' NULL '' ENCODING 'UTF8';
--obdobne importujte sites, patient_study
--studies_sites ss pokuste naplnit z udaju v tabulce patient_study sloupce study_id, study_site 


--Následující příkazy zajistí integritu (provázání) tabulek. Nejsou nutné, pouze zajisté, 
--aby např. nebylo možné do tabulky patient_study vložit záznam pacienta,který dosud nebyl 
--definován v tabulce patient. Můžete vyzkoušet před spuštěním následujících příkazů 
--a po jejich spuštění  

ALTER TABLE patients ADD 

    CONSTRAINT pk_patient

    PRIMARY KEY (patient_id);



ALTER TABLE patient_study ADD 

    CONSTRAINT pk_patient_study

    PRIMARY KEY (patient_id, study_id);



ALTER TABLE studies ADD 

    CONSTRAINT pk_studies

    PRIMARY KEY (study_id);



ALTER TABLE studies_sites ADD 

    CONSTRAINT pk_studies_sites

    PRIMARY KEY (study_id, site_id);



ALTER TABLE sites ADD 

    CONSTRAINT pk_sites

    PRIMARY KEY (site_id); 



     

ALTER TABLE patient_study ADD 

    CONSTRAINT fk_patient_study_patients

    FOREIGN KEY (patient_id)

    REFERENCES patients (patient_id);



ALTER TABLE patient_study ADD 

    CONSTRAINT fk_patient_study_studies

    FOREIGN KEY (study_id)

    REFERENCES studies (study_id);    



ALTER TABLE patient_study ADD 

    CONSTRAINT fk_patient_study_sites

    FOREIGN KEY (study_site)

    REFERENCES sites (site_id);    



ALTER TABLE studies_sites ADD 

    CONSTRAINT fk_studies_sites_studies

    FOREIGN KEY (study_id)

    REFERENCES studies (study_id);



ALTER TABLE studies_sites ADD 

    CONSTRAINT fk_studies_sites_sites

    FOREIGN KEY (site_id)

    REFERENCES sites (site_id);
    
    
--spusťte ostatní soubory s příponou sql





    